﻿using HarmonyLib;
using System.Collections;
using System.Reflection;
using UnityEngine;
using UnityEngine.Networking;

public class DragonSeagulls : Mod
{
    private AssetBundle asset;
    Harmony harmonyInstance;
    string harmonyId = "fr.tekgamer.dragonseagulls";
    public static Material greenColor;
    public static Material redColor;
    public static Material blueColor;
    public static Material purpleColor;
    public static GameObject dragonPrefab;

    public IEnumerator Start()
    {
        harmonyInstance = new Harmony(harmonyId);
        harmonyInstance.PatchAll(Assembly.GetExecutingAssembly());
        var request = AssetBundle.LoadFromMemoryAsync(GetEmbeddedFileBytes("dragonseagulls.assets"));
        yield return request;
        asset = request.assetBundle;
        greenColor = asset.LoadAsset<Material>("GreenHP");
        redColor = asset.LoadAsset<Material>("RedHP");
        blueColor = asset.LoadAsset<Material>("BlueHP");
        purpleColor = asset.LoadAsset<Material>("PurpleHP");
        dragonPrefab = asset.LoadAsset<GameObject>("DragonPrefab");
        ToggleDisplay(true);
        Debug.Log("DragonSeagulls has been successfully loaded!");
    }

    public static void ToggleDisplay(bool val)
    {
        if (val)
        {
            foreach (Seagull s in FindObjectsOfType<Seagull>())
            {
                s.GetComponentInChildren<SkinnedMeshRenderer>().enabled = false;
                if (!s.transform.Find("DRAGONSEAGULLS_OBJECT"))
                {
                    GameObject dragon = Instantiate(dragonPrefab, s.transform.position, s.transform.rotation, s.transform);
                    dragon.name = "DRAGONSEAGULLS_OBJECT";
                    int color = Random.Range(1, 4);
                    if (color == 1)
                    {
                        dragon.GetComponentInChildren<SkinnedMeshRenderer>().sharedMaterial = greenColor;
                    }
                    else if (color == 2)
                    {
                        dragon.GetComponentInChildren<SkinnedMeshRenderer>().sharedMaterial = redColor;
                    }
                    else if (color == 3)
                    {
                        dragon.GetComponentInChildren<SkinnedMeshRenderer>().sharedMaterial = blueColor;
                    }
                    else
                    {
                        dragon.GetComponentInChildren<SkinnedMeshRenderer>().sharedMaterial = purpleColor;
                    }
                    dragon.transform.localScale = new Vector3(0.5f, 0.5f, 0.5f);
                }
            }
        }
        else
        {
            int i = 0;
            foreach (Seagull s in FindObjectsOfType<Seagull>())
            {
                s.GetComponentInChildren<SkinnedMeshRenderer>().enabled = true;
                Transform dragon = s.transform.Find("DRAGONSEAGULLS_OBJECT");
                if (dragon)
                {
                    DestroyImmediate(dragon.gameObject);
                    i++;
                }
            }
            Debug.Log("Successfully unloaded " + i + " dragons! :P");
        }

    }

    public void OnModUnload()
    {
        ToggleDisplay(false);
        harmonyInstance.UnpatchAll(harmonyId);
        asset.Unload(true);
    }
}

[HarmonyPatch(typeof(Network_Host_Entities))]
[HarmonyPatch("CreateSeagull")]
public static class HarmonyPatch_DisableAchievements
{
    private static void Postfix()
    {
        DragonSeagulls.ToggleDisplay(true);
    }
}